CLS
@ECHO OFF
@ECHO.
@ECHO ################################
@ECHO ### For N8103-116A/117A/118A ###
@ECHO ### SETUP.BAT START!!        ###
@ECHO ################################


:SETMFC
@ECHO.
@ECHO #### Set MFC #####
@ECHO.
MegaOem -AdpSettings Read -f ruchef_2.ini -a0
MegaOem -AdpSettings Write -f LOG.TXT -a0
SETUPCHK.EXE -MFCCHK LOG.TXT ruchef_2.ini
IF ERRORLEVEL 1 GOTO FACDEF
IF ERRORLEVEL 0 GOTO ERROR

:FACDEF
@ECHO.
@ECHO #### Set Factory Default #####
@ECHO.

Megacli -AdpFacDefSet -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SETPROP
IF ERRORLEVEL 0 GOTO ERROR

:SETPROP
@ECHO.
@ECHO ################################
@ECHO #### Set Adapter Properties ####
@ECHO ################################
@ECHO.

:PREDFAIL
@ECHO.
@echo #### Set PDF Interval ####
@ECHO.
megacli -AdpSetProp PredFailPollInterval 300 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO REBUILD
IF ERRORLEVEL 0 GOTO ERROR

:REBUILD
@ECHO.
@echo #### Set Rebuild Rate ####
@ECHO.
megacli -AdpSetProp RebuildRate 30 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO PATROL
IF ERRORLEVEL 0 GOTO ERROR

:PATROL
@ECHO.
@echo #### Set Patrol Read Rate ####
@ECHO.
megacli -AdpSetProp PatrolReadRate 30 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO BGIRATE
IF ERRORLEVEL 0 GOTO ERROR

:BGIRATE
@ECHO.
@echo #### Set BGI Rate ####
@ECHO.
megacli -AdpSetProp BgiRate 30 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO CONSIS
IF ERRORLEVEL 0 GOTO ERROR

:CONSIS
@ECHO.
@echo #### Set CC Rate ####
@ECHO.
megacli -AdpSetProp CCRate 30 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO RECON
IF ERRORLEVEL 0 GOTO ERROR

:RECON
@ECHO.
@echo #### Set Reconstraction Rate ####
@ECHO.
megacli -AdpSetProp ReconRate 30 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO CACHE
IF ERRORLEVEL 0 GOTO ERROR

:CACHE
@ECHO.
@echo #### Set Cache Flush Interval ####
@ECHO.
MegaCli -AdpSetProp CacheFlushInterval 4 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SPINDRV
IF ERRORLEVEL 0 GOTO ERROR


:SPINDRV
@ECHO.
@echo #### Set Spinup Drive Count ####
@ECHO.
megacli -AdpSetProp SpinupDriveCount 2 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SPINDLY
IF ERRORLEVEL 0 GOTO ERROR

:SPINDLY
@ECHO.
@echo #### Set Spinup Delay ####
@ECHO.
megacli -AdpSetProp SpinupDelay 12 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO CLUSTER
IF ERRORLEVEL 0 GOTO ERROR

:CLUSTER
@ECHO.
@echo #### Set Cluster Mode ####
@ECHO.
megacli -AdpSetProp ClusterEnable 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO COERCION
IF ERRORLEVEL 0 GOTO ERROR

:COERCION
@ECHO.
@echo #### Set Coercion Mode ####
@ECHO.
megacli -AdpSetProp CoercionMode 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO ALARM
IF ERRORLEVEL 0 GOTO ERROR

:ALARM
@ECHO.
@echo #### Set Alarm Control ####
@ECHO.
megacli -AdpSetProp AlarmDsbl -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO BATTERY
IF ERRORLEVEL 0 GOTO ERROR

:BATTERY
@ECHO.
@echo #### Set Battery Warning ####
@ECHO.
megacli -AdpSetProp BatWarnDsbl 1 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO ECCSIZE
IF ERRORLEVEL 0 GOTO ERROR

:ECCSIZE
@ECHO.
@echo #### Set Ecc Bucket Size ####
@ECHO.
megacli -AdpSetProp EccBucketSize 15 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO ECCRATE
IF ERRORLEVEL 0 GOTO ERROR

:ECCRATE
@ECHO.
@echo #### Set Ecc Bucket Leak Rate ####
@ECHO.
megacli -AdpSetProp EccBucketLeakRate 1440 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO CCERR
IF ERRORLEVEL 0 GOTO ERROR

:CCERR
@ECHO.
@echo #### Set Abort CC on Error ####
@ECHO.
MegaCli -AdpSetProp AbortCCOnError 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SMCPBK
IF ERRORLEVEL 0 GOTO ERROR

:SMCPBK
@ECHO.
@echo #### Set SMART COPYBACK ####
@ECHO.
MegaCli -AdpSetProp SMARTCpyBkEnbl 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO NCQDSBL
IF ERRORLEVEL 0 GOTO ERROR

:NCQDSBL
@ECHO.
@echo #### Set NCQ ####
@ECHO.
MegaCli -AdpSetProp NCQDsbl -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SSDSMCB
IF ERRORLEVEL 0 GOTO ERROR

:SSDSMCB
@ECHO.
@echo #### Set SSD SMART COPYBACK ####
@ECHO.
MegaCli -AdpSetProp SSDSMARTCpyBkEnbl 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SPINDOWN
IF ERRORLEVEL 0 GOTO ERROR

:SPINDOWN
@ECHO.
@echo #### Set Spin Down Unconfigured GOOD ####
@ECHO.
MegaCli -AdpSetProp EnblSpinDownUnConfigDrvs 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SSDPR1
IF ERRORLEVEL 0 GOTO ERROR

:SSDPR1
@ECHO.
@echo #### Set SSD Patrol Read 1 ####
@ECHO.
MegaCli -AdpSetProp EnblSSDPatrolRead 1 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO DETECTBP
IF ERRORLEVEL 0 GOTO ERROR

:DETECTBP
@ECHO.
@echo #### Set Auto Detect Back Plane ####
@ECHO.
MegaCli -AdpSetProp -AutoDetectBackPlaneDsbl 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO COPYBK
IF ERRORLEVEL 0 GOTO ERROR

:COPYBK
@ECHO.
@echo #### Set COPYBACK ####
@ECHO.
MegaCli -AdpSetProp -CopyBackDsbl 1 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO LOADBL
IF ERRORLEVEL 0 GOTO ERROR

:LOADBL
@ECHO.
@echo #### Set Load Balance ####
@ECHO.
MegaCli -AdpSetProp -LoadBalanceMode 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO USEFDE
IF ERRORLEVEL 0 GOTO ERROR

:USEFDE
@ECHO.
@echo #### Set Use FDE ####
@ECHO.
MegaCli -AdpSetProp -UseFDEOnlyEncrypt 0 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO PRAUTO
IF ERRORLEVEL 0 GOTO ERROR

:PRAUTO
@ECHO.
@echo #### Set Patrol Read ####
@ECHO.
MegaCli -AdpPR EnblAuto -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO PRDELAY
IF ERRORLEVEL 0 GOTO ERROR

:PRDELAY
@ECHO.
@echo #### Set Patrol Read Delay ####
@ECHO.
MegaCli -AdpPR SetDelay 228 -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO SSDPR2
IF ERRORLEVEL 0 GOTO ERROR

:SSDPR2
@ECHO.
@echo #### Set SSD Patrol Read 2 ####
@ECHO.
MegaCli -AdpPR SSDPatrolReadEnbl -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO CCSCDL
IF ERRORLEVEL 0 GOTO ERROR

:CCSCDL
@ECHO.
@echo #### Set CC Schedule ####
@ECHO.
MegaCli -AdpCcSched Dsbl -a0 > LOG.TXT
SETUPCHK.EXE -EXITCODE LOG.TXT
IF ERRORLEVEL 1 GOTO FINISH
IF ERRORLEVEL 0 GOTO ERROR

:FINISH
@ECHO.
@ECHO ###############################
@ECHO ###  SETUP.BAT FINISHED!!   ###
@ECHO ###############################
@ECHO.

del LOG.TXT
GOTO END

:ERROR
@ECHO.
@ECHO ############################
@ECHO ###  SETUP.BAT ERROR!!   ###
@ECHO ############################
@ECHO.
GOTO END

:END
